import 'dart:developer';

import 'package:dio/dio.dart';
import 'package:flutter/cupertino.dart';
import 'package:shared_preferences/shared_preferences.dart';

class HttpRequestClass {
  var dio = Dio();
  var defaultType = "application/vnd.api+json";

  Future<Response<dynamic>> Request(String url, String method,
      {Object? data, Map<String, dynamic>? params, bool auth: false}) async {
    try {
      print("Request $method $url");

      // set auth
      if (auth) {
        final prefs = await SharedPreferences.getInstance();
        var at = prefs.getString("MBaaS.auth.accessToken");
        if (at == null) throw ("Authentication required!");

        dio.options = BaseOptions(headers: {
          "Authorization": "Bearer $at",
          "accept": defaultType,
          Headers.contentTypeHeader: defaultType
        });
      } else {
        dio.options = BaseOptions(
          headers: {
            "accept": defaultType,
            Headers.contentTypeHeader: defaultType
          },
          // followRedirects: false,
          // // will not throw errors
          // validateStatus: (status) => true
        );
      }
      print(dio.options.headers);

      var response = await dio.request(
        url,
        data: data,
        queryParameters: params,
        options: Options(method: method),
      );


      return response;
    } on DioError catch (e) {
      print("error get");
      if (e.response != null) {
        print("res != null");
        print(e.response!.data);
        print(e.response!.headers);
        print(e.response!.requestOptions);
        throw (e.response!.data);
      } else {
        // Something happened in setting up or sending the request that triggered an Error
        print(e.requestOptions);
        print(e.message);
        throw (e.message);
      }
    }
  }
}
